#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{    long long n,k,br=1,p,q;
    cin>>n>>k;
    long long a[n];
    for(long long i=0;i<n;i++)
        cin>>a[i];
    sort(a,a+n);
    p=a[0];
    for(int i=1;i<=n;i++)
    {
        if(a[i]==p)
        {
            br++;
            p=a[i];
        }
        else
        {
            if(br>=k)
                {
                    cout<<p<<" ";
                    br=1;
                }
            p=a[i];
        }
    }
    return 0;
}